#!/usr/bin/env python

from simplex import *
import sys, time

try:
    separator = sys.argv.index("--")
    filename, numeric = sys.argv[1:3]
    fields = map(int, sys.argv[3:separator])
    terms = groups(sys.argv[separator+1:], len(fields))
except (IndexError, ValueError):
    print >>sys.stderr, "Usage: %s <filename> <numeric> <field>... -- <term value>..." % sys.argv[0]
    sys.exit(1)

f = open(filename)
accessor = DelimitedRecord(fields, numeric=(numeric == "true"))

try:
    for term in terms:

        # Convert the term to the appropriate type.

        term = accessor.convert(term)

        # Perform the search.

        f.seek(0)

        t = time.time()
        lines = find_in_file(f, accessor.get_key, term)
        if lines:
            print >>sys.stderr, "Found (at %s seconds)..." % (time.time() - t)
            for line in lines:
                sys.stdout.write(line)
finally:
    f.close()

# vim: tabstop=4 expandtab shiftwidth=4
